#if (!defined(KLL0_INCLUDED))

#define KLL0_INCLUDED		1

#include "kbcl0.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

struct KStringId_Elmt {
	int l;
	const char *p;
	unsigned int h;
	int n;
	inline KStringId_Elmt() { }
	inline KStringId_Elmt(int l_, const char *p_ = 0, unsigned int h_ = 0, int n_ = 0) : l(l_), p(p_), h(h_), n(n_) { }
};

struct KStringId {
	KMemPool *mp;
	KIndexDict3 *dict, *dict0;
	int *n, *n0, f;
	KSizPtr *sp, *sp0;
	KStringId *initSub();
	KStringId *add(const char *s);
	KStringId_Elmt *addSub0(int l, const char *p, unsigned int h);
	KStringId_Elmt *addSub1(int l, const char *p);
	KStringId *ins(const char *s);
	KStringId(KMemPool *mp_ = kmemPool, KIndexDict3 *dict_ = 0, int *n_ = 0, KSizPtr *sp_ = 0);
	KStringId(int f_, KMemPool *mp_ = kmemPool, KIndexDict3 *dict_ = 0, int *n_ = 0, KSizPtr *sp_ = 0);
	KStringId(const char *s, KMemPool *mp_ = kmemPool, KIndexDict3 *dict_ = 0, int *n_ = 0, KSizPtr *sp_ = 0);
	KStringId(int f_, const char *s, KMemPool *mp_ = kmemPool, KIndexDict3 *dict_ = 0, int *n_ = 0, KSizPtr *sp_ = 0);
	inline KStringId *sort() { dict->sort(); return this; }
	int search0(KStringId_Elmt *k); // htB[hQƂ.
	int search1(KStringId_Elmt *k); // htB[hQƂȂ.
	int getId0(int l, const char *s, unsigned int h) { KStringId_Elmt k(l, s, 0, h); return search0(&k); }
	int getId0(int l, const char *s) { KStringId_Elmt k(l, s); return search1(&k); }
	int getId0(const char *s);
	int getId1(int l, const char *s); // o^ȂǉĂidԂ.
	inline KStringId_Elmt *getStr(int i) { return (KStringId_Elmt *) sp->getPtr(i); }
	static void *dest(KStringId *p);
	inline ~KStringId() { KStringId::dest(this); }
};

char *kinitChrTypA(char *t = 0, KAutoreleasePool *ap = kautoreleasePool);

struct KLexer_Elmt {
	int i;
	const char *p0;
};

int ksearchToken0(const unsigned char *s, int i, int i1, const char *chrTyp);
int ksearchToken1(const unsigned char *s, int i, int i1, const char *chrTyp);
unsigned char *kupperCaseM(int l, unsigned char *s, const char *chrTyp);
int kphrCmp0(int l1, int *ic, const char *s, KLexer_Elmt *le, KStringId *sid);

struct KLexer {
	KMemPool *mp;
	int szElm;
	KStringId *sid, *sid0;
	char *chrTyp, *chrTyp0;
	KSizPtr *sp, *sp0;
	KLexer(KStringId *sid_ = 0, KMemPool *mp_ = kmemPool, int szElm_ = sizeof (KLexer_Elmt), char *chrTyp_ = 0, KSizPtr *sp_ = 0);
	KSizPtr *add(int l, const char *s);
	const char *errStr;
	int getConstInt(int i);
	int testConstInt(int i);
	inline int getElmtLen() { return sp->s / szElm; }
	static void *dest(KLexer *p);
	inline ~KLexer() { KLexer::dest(this); }
};

int kputBin(unsigned char *q, const char *s, ...);
void *kmallocRWX(int siz);
int kstrtol0(int l, const char *s, int base);

#endif

